#!/usr/bin/env python
#
#   This file is part of IntiPunku
#   Copyright (C) 2007 Mark Baas <mark.baas123@gmail.com>
#
#   This program is free software: you can redistribute it and/or modify
#   it under the terms of the GNU Affero General Public License as
#   published by the Free Software Foundation, either version 3 of the
#   License, or (at your option) any later version.
#
#   This program is distributed in the hope that it will be useful,
#   but WITHOUT ANY WARRANTY; without even the implied warranty of
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#   GNU Affero General Public License for more details.
#
#   You should have received a copy of the GNU Affero General Public License
#   along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
# This file need cleanup


import os, os.path, random, sys, gobject
from distutils import file_util, dir_util
from datetime import datetime
import time
from PIL import Image
import gtk
import sqlite3
from threading import Thread
from inti import dialogs

from inti.constants import *

try: import gconf
except:
    print "Gconf module not found"

if WIN:
    import _winreg 
    import win32gui


# Localization
import gettext
_ = gettext.gettext

SunProgress = dialogs.SunProgress

def sunthread(target, args):
    thread = Thread(target=target,args=args)
    thread.start()
    while thread.isAlive():
        while gtk.events_pending(): gtk.main_iteration()
 
def random_string():
    chars = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789"
    string = ""
    for i in random.sample(chars, 30):
        string += i
    return string

def load_icon(name, size=SYS_ICONSIZE, local=None):
    theme = gtk.icon_theme_get_default()
    if not ICONDIR in theme.get_search_path():
        theme.prepend_search_path(ICONDIR)
        if MAC or WIN:
            theme.append_search_path(ICONDIR + "_system")
    if not theme.has_icon(name):
        print "icon %s not found" % name
        name = "intipunku"
    return theme.load_icon(name,size, gtk.ICON_LOOKUP_NO_SVG)

def isvalidfile(path):
    if not os.path.isfile(path):
        return False
    f = os.path.basename(path)

    for skip in SKIPFILES:
        skip2 = skip.strip("*")
        if skip.endswith("*"):
            return not f.startswith(skip2)
        elif skip.startswith("*"):
            return not f.endswith(skip2)
        else:
            return skip2 in f

def isvaliddir(path):    
    if not os.path.isdir(path):
        return False
    d = os.path.basename(path)

    for skip in SKIPDIRS:
        skip2 = skip.strip("*")
        if skip.endswith("*"):
            return not d.startswith(skip2)
        elif skip.startswith("*"):
            return not d.endswith(skip2)
        else:
            return skip2 in d

def hex_to_rgb(color):
    """convert a hex color such as #FFFFFF to a red, green, blue tuple"""
    if len(color) > 7:
        c = color[1:]
        n = len(c)/3
        c1 = color[1:n+1][:2]
        c2 = color[n+1:n*2+1][:2]
        c3 = color[n*2+1:][:2]
        color = "#" + c1 + c2 + c3
    c = eval('0x' + color[1:])
    r = (c >> 16) & 0xFF
    g = (c >> 8) & 0xFF
    b = c & 0xFF
    return (r/255.0, g/255.0, b/255.0)
    

def rgb_to_hex(rgb_tuple):
    """ convert an (R, G, B) tuple to #RRGGBB """
    hexcolor = '#%02x%02x%02x' % rgb_tuple
    # that's it! '%02x' means zero-padded, 2-digit hex values
    return hexcolor

def register_icons():
    factory = gtk.IconFactory()
    icons = ["rotate-left", "rotate-right", "wallpaper", "go-top","html","slideshow", "panorama", "go-bottom", "tag2",
            "clock", "export", "import"]
    for icon in icons:
        pixbuf = load_icon(icon)
        iconset = gtk.IconSet(pixbuf)
        factory.add(icon, iconset)
        factory.add_default()
        
        
def set_default_import():
    # win32: ??
    
    # Gnome: /desktop/gnome/volume_manager/autophoto_command
    auth_key = "/desktop/gnome/volume_manager/autophoto_command"
    auth_token = gconf.client_get_default().set_string(auth_key, "intipunku-import --camera")
    
    # KDE: ? Intipunku is more a gnome app so...
    
    
def set_default_viewer():
    # win32: HKEY_CLASSES_ROOT\ SystemFileAssociations \ image \ shell \ edit \ command
    pass
    
    
def set_lang_win32(lang):
    x=_winreg.ConnectRegistry(None,_winreg.HKEY_LOCAL_MACHINE)
    y= _winreg.OpenKey(x,"SYSTEM\CurrentControlSet\Control\Session Manager\Environment", 0,_winreg.KEY_ALL_ACCESS)
    _winreg.SetValueEx(y,"LANG",0,_winreg.REG_SZ,lang)
    _winreg.CloseKey(y)
    _winreg.CloseKey(x)
    
    # Refresh environment
    HWND_BROADCAST      = 0xFFFF
    WM_SETTINGCHANGE    = 0x001A
    SMTO_ABORTIFHUNG    = 0x0002
    sParam              = "Environment"

    res1, res2          = win32gui.SendMessageTimeout(HWND_BROADCAST,
                            WM_SETTINGCHANGE, 0, sParam, SMTO_ABORTIFHUNG, 100)
    if  not res1:
        print ("result %s, %s from SendMessageTimeout" % (bool(res1), res2))


def inpath(f):
    f += EXEXT
    path = os.environ["PATH"].split(VSEP)
    found = False
    for d in path:
        if not os.path.exists(d): continue
        if f in os.listdir(d):
            found = True
            break
    return found
    
def report_error(msg, type="error"):
    if "error": type = gtk.MESSAGE_ERROR
    if "warning": type = gtk.MESSAGE_WARNING
    dialog = gtk.MessageDialog(type=type,buttons=gtk.BUTTONS_OK)
    dialog.set_icon_name("dialog-question")
    dialog.set_markup(msg)
    r = dialog.run()
    dialog.destroy()
    
notify_win = None
def notify(f, msg, win=None):
    global notify_win
    if not isvalidfile(f): return
    
    if notify_win != None and notify_win.get_property("visible"):
        notify_win.update(f, msg)
    else:
        win = dialogs.NotifyWindow(f, msg, win)
        win.show_all()
        notify_win = win
    

